/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.taihe.register;

import org.apache.dubbo.common.stream.StreamObserver;

import java.util.concurrent.CompletableFuture;

public interface TaiheRegisterService extends org.apache.dubbo.rpc.model.DubboStub {

    String JAVA_SERVICE_NAME = "com.ywt.gapi.taihe.register.TaiheRegisterService";
    String SERVICE_NAME = "com.ywt.gapi.taihe.register.TaiheRegisterService";

        /**
         * <pre>
         * 医生职称
         * </pre>
         */
    CreateRegisteredResponse createRegistered(CreateRegisteredRequest request);

    default CompletableFuture<CreateRegisteredResponse> createRegisteredAsync(CreateRegisteredRequest request){
        return CompletableFuture.completedFuture(createRegistered(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void createRegistered(CreateRegisteredRequest request, StreamObserver<CreateRegisteredResponse> responseObserver){
        createRegisteredAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 科室Code
         * </pre>
         */
    com.ywt.gapi.taihe.register.CancelRegisteredResponse cancelRegistered(com.ywt.gapi.taihe.register.CancelRegisteredRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.CancelRegisteredResponse> cancelRegisteredAsync(com.ywt.gapi.taihe.register.CancelRegisteredRequest request){
        return CompletableFuture.completedFuture(cancelRegistered(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void cancelRegistered(com.ywt.gapi.taihe.register.CancelRegisteredRequest request, StreamObserver<com.ywt.gapi.taihe.register.CancelRegisteredResponse> responseObserver){
        cancelRegisteredAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 科室名称
         * </pre>
         */
    PayCallbackResponse payCallback(PayCallbackRequest request);

    default CompletableFuture<PayCallbackResponse> payCallbackAsync(PayCallbackRequest request){
        return CompletableFuture.completedFuture(payCallback(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void payCallback(PayCallbackRequest request, StreamObserver<PayCallbackResponse> responseObserver){
        payCallbackAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 医生Code
         * </pre>
         */
    RefundCallbackResponse refundCallback(RefundCallbackRequest request);

    default CompletableFuture<RefundCallbackResponse> refundCallbackAsync(RefundCallbackRequest request){
        return CompletableFuture.completedFuture(refundCallback(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void refundCallback(RefundCallbackRequest request, StreamObserver<RefundCallbackResponse> responseObserver){
        refundCallbackAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 医生名称
         * </pre>
         */
    com.ywt.gapi.taihe.register.RegisterResponse register(RegisterRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.RegisterResponse> registerAsync(RegisterRequest request){
        return CompletableFuture.completedFuture(register(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void register(RegisterRequest request, StreamObserver<com.ywt.gapi.taihe.register.RegisterResponse> responseObserver){
        registerAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 预约挂号总费用
         * </pre>
         */
    com.ywt.gapi.taihe.register.TakeResponse take(TakeRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.TakeResponse> takeAsync(TakeRequest request){
        return CompletableFuture.completedFuture(take(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void take(TakeRequest request, StreamObserver<com.ywt.gapi.taihe.register.TakeResponse> responseObserver){
        takeAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 挂号费
         * </pre>
         */
    GetQueueListResponse getQueueList(com.ywt.gapi.taihe.register.GetQueueListRequest request);

    default CompletableFuture<GetQueueListResponse> getQueueListAsync(com.ywt.gapi.taihe.register.GetQueueListRequest request){
        return CompletableFuture.completedFuture(getQueueList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getQueueList(com.ywt.gapi.taihe.register.GetQueueListRequest request, StreamObserver<GetQueueListResponse> responseObserver){
        getQueueListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 诊查费
         * </pre>
         */
    GetCommonOrderListResponse getCommonOrderList(GetCommonOrderListRequest request);

    default CompletableFuture<GetCommonOrderListResponse> getCommonOrderListAsync(GetCommonOrderListRequest request){
        return CompletableFuture.completedFuture(getCommonOrderList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getCommonOrderList(GetCommonOrderListRequest request, StreamObserver<GetCommonOrderListResponse> responseObserver){
        getCommonOrderListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 预约日期
         * </pre>
         */
    GetRegisteredListResponse getRegisteredList(GetRegisteredListRequest request);

    default CompletableFuture<GetRegisteredListResponse> getRegisteredListAsync(GetRegisteredListRequest request){
        return CompletableFuture.completedFuture(getRegisteredList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getRegisteredList(GetRegisteredListRequest request, StreamObserver<GetRegisteredListResponse> responseObserver){
        getRegisteredListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 预约时间段
         * </pre>
         */
    com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardResponse registerWithoutMedicalCard(com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardResponse> registerWithoutMedicalCardAsync(com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardRequest request){
        return CompletableFuture.completedFuture(registerWithoutMedicalCard(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void registerWithoutMedicalCard(com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardRequest request, StreamObserver<com.ywt.gapi.taihe.register.RegisterWithoutMedicalCardResponse> responseObserver){
        registerWithoutMedicalCardAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 预约开始时间：HH:MI
         * </pre>
         */
    GetOfflineConsultInfoByDoctorIdResponse getOfflineConsultInfoByDoctorId(GetOfflineConsultInfoByDoctorIdRequest request);

    default CompletableFuture<GetOfflineConsultInfoByDoctorIdResponse> getOfflineConsultInfoByDoctorIdAsync(GetOfflineConsultInfoByDoctorIdRequest request){
        return CompletableFuture.completedFuture(getOfflineConsultInfoByDoctorId(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getOfflineConsultInfoByDoctorId(GetOfflineConsultInfoByDoctorIdRequest request, StreamObserver<GetOfflineConsultInfoByDoctorIdResponse> responseObserver){
        getOfflineConsultInfoByDoctorIdAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 预约结束时间：HH:MI
         * </pre>
         */
    GetLatestRegOrderResponse getLatestRegOrder(GetLatestRegOrderRequest request);

    default CompletableFuture<GetLatestRegOrderResponse> getLatestRegOrderAsync(GetLatestRegOrderRequest request){
        return CompletableFuture.completedFuture(getLatestRegOrder(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getLatestRegOrder(GetLatestRegOrderRequest request, StreamObserver<GetLatestRegOrderResponse> responseObserver){
        getLatestRegOrderAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 用户ID
         * </pre>
         */
    com.ywt.gapi.taihe.register.CalAdditionalFeeResponse calAdditionalFee(com.ywt.gapi.taihe.register.CalAdditionalFeeRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.CalAdditionalFeeResponse> calAdditionalFeeAsync(com.ywt.gapi.taihe.register.CalAdditionalFeeRequest request){
        return CompletableFuture.completedFuture(calAdditionalFee(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void calAdditionalFee(com.ywt.gapi.taihe.register.CalAdditionalFeeRequest request, StreamObserver<com.ywt.gapi.taihe.register.CalAdditionalFeeResponse> responseObserver){
        calAdditionalFeeAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 诊疗卡ID
         * </pre>
         */
    GetHisPatientIdByUserIdAndMobileResponse getHisPatientIdByUserIdAndMobile(com.ywt.gapi.taihe.register.GetHisPatientIdByUserIdAndMobileRequest request);

    default CompletableFuture<GetHisPatientIdByUserIdAndMobileResponse> getHisPatientIdByUserIdAndMobileAsync(com.ywt.gapi.taihe.register.GetHisPatientIdByUserIdAndMobileRequest request){
        return CompletableFuture.completedFuture(getHisPatientIdByUserIdAndMobile(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getHisPatientIdByUserIdAndMobile(com.ywt.gapi.taihe.register.GetHisPatientIdByUserIdAndMobileRequest request, StreamObserver<GetHisPatientIdByUserIdAndMobileResponse> responseObserver){
        getHisPatientIdByUserIdAndMobileAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 门诊排班项记录标识
         * </pre>
         */
    CreateMedicalCardResponse createMedicalCard(com.ywt.gapi.taihe.register.CreateMedicalCardRequest request);

    default CompletableFuture<CreateMedicalCardResponse> createMedicalCardAsync(com.ywt.gapi.taihe.register.CreateMedicalCardRequest request){
        return CompletableFuture.completedFuture(createMedicalCard(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void createMedicalCard(com.ywt.gapi.taihe.register.CreateMedicalCardRequest request, StreamObserver<CreateMedicalCardResponse> responseObserver){
        createMedicalCardAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 支付渠道
         * </pre>
         */
    com.ywt.gapi.taihe.register.RegisterCheckInMessageResponse registerCheckInMessage(com.ywt.gapi.taihe.register.RegisterCheckInMessageRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.register.RegisterCheckInMessageResponse> registerCheckInMessageAsync(com.ywt.gapi.taihe.register.RegisterCheckInMessageRequest request){
        return CompletableFuture.completedFuture(registerCheckInMessage(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void registerCheckInMessage(com.ywt.gapi.taihe.register.RegisterCheckInMessageRequest request, StreamObserver<com.ywt.gapi.taihe.register.RegisterCheckInMessageResponse> responseObserver){
        registerCheckInMessageAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }






}
